//////////////////////////////////////////////////////////////////////////////////////////////////////
//      FINAL WORKING CODE      FINAL WORKING CODE      FINAL WORKING CODE      FINAL WORKING CODE  //
//////////////////////////////////////////////////////////////////////////////////////////////////////
//
//LabGuy's World Test Program #3 (actual code for the 10-4 Eleanor)
// R. Diehl 20201206  Version 1.04
//
//Compatible with the Arduino IDE 1.0
//Library version:1.1
//
//
//  THIS IS BASED ON THE VIDEO #19 BY RALPH S BACON ON YOUTUBE
//

#include <Wire.h> 
#include <Encoder.h>
#include <LiquidCrystal_I2C.h>

// Define the Encoder pins and variables
int switchPin = 12;                       // Button pin
int switchState = HIGH;                   // button value
int pinA = 4;                             // Rotary encoder pin A
int pinB = 3;                             // Rotary encoder pin B
int pinAstateCurrent = LOW;                // Current state of pin A
int pinAStateLast = pinAstateCurrent;     // Last read value of Pin A

// Initialize the LCD display driver, define this hardware's properties,
// as LCD I2C address is 0x27 and display is 20 chars wide by 4 lines high.
LiquidCrystal_I2C lcd(0x27,20,4);  

// Define application variables

unsigned char FrameNumber = 0;                      // Frame select port variable
unsigned char FrameNumberLast = 0;                  // Memorized frame num to detect changes
void setup() {

// Initialize Rotary Encoder and Push Button
  pinMode (switchPin, INPUT_PULLUP);       // Set pin for push button to reading mode
  pinMode (pinA, INPUT);                   // Set encoder pinA as input
  pinMode (pinB, INPUT);                   // Set encoder pinB as input

// Attach a CHANGE interrupt to pinB and execute the function when this change occurs
  attachInterrupt(digitalPinToInterrupt(pinB), update, CHANGE);

// Frame Select Port Initialize to Frame Zero
  Wire.beginTransmission(0x20);
  Wire.write(0xFF);
  Wire.endTransmission();

  // initialize the lcd 
  lcd.init();                      
  // Print a message to the LCD.
  lcd.backlight();
  lcd.setCursor(0,0);
  lcd.print("Eleanor, RGBY  Color");
  lcd.setCursor(0,1);
  lcd.print("NBTV Video Generator");
  lcd.setCursor(1,2);
  lcd.print("By Labguy's World");
  lcd.setCursor(0,3);
  lcd.print("Ver. 1.04   20201206");

  delay(3000);
  lcd.setCursor(0,3);
  lcd.print("Frame Number:       ");
  FrameNumberLast = 1;
}

// Main Loop 
void loop() {
  if (FrameNumber - FrameNumberLast != 0){
  FrameNumberLast = FrameNumber;
  lcd.setCursor(14,3);
  lcd.print("    ");
  lcd.setCursor(14,3);
  lcd.print(FrameNumber);
  Wire.beginTransmission(0x20);
  Wire.write(FrameNumber);
  Wire.endTransmission();
  }
}

////////////////////////////////////////////////////////////////////////////////////////////////////
//      INTERRUPT      INTERRUPT      INTERRUPT      INTERRUPT      INTERRUPT      INTERRUPT      //
////////////////////////////////////////////////////////////////////////////////////////////////////
// Encoder Interrupt Service Routine
//
void update() {
  // Rotation direction
  pinAstateCurrent = digitalRead(pinA);     // Read the current state of pin A

  // If there is minimal movement of 1 step
  if ((pinAStateLast == LOW) && (pinAstateCurrent == HIGH)) {

    if (digitalRead(pinB) == HIGH) {
    FrameNumber++;
  } else {
    FrameNumber--;
  }
}
pinAStateLast = pinAstateCurrent;
delay(60);
}
